class EvenNumber implements Comparable<EvenNumber> {
    private int num;

    EvenNumber(int num) {
        this.num = num;
    }

    public EvenNumber next() {
        return new EvenNumber(num + 2);
    }

    public EvenNumber previous() {
        return new EvenNumber(num - 2);
    }

    @Override
    int compareTo(EvenNumber o) {
        return Integer.compare(num, o.num);
    }

    @Override
    public String toString() {
        return "EvenNumber{" +
                "num=" + num +
                '}';
    }
}

def theRange = new EvenNumber(4)..new EvenNumber(8)
for (def r : theRange) {
    println r
}
//reverse
println '-- reverse --'
theRange = new EvenNumber(8)..new EvenNumber(4)
for (def r : theRange) {
    println r
}